<?php
/*
Copyright (C) 2009 Anja S. Gritz <http://www.goeritz.net>
This file is part of phpPanelAdmin.

phpPanelAdmin is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

phpPanelAdmin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpPanelAdmin. If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
if(!isset($_SESSION['admin']))
{
echo "Processing impossible!<br>";
echo "<a href=\"index.php\">Login?</a>";
}
else //cookie is there
{
echo "<html><head><title>Duplicates</title>";
require 'header.php';

$sql = "SELECT * FROM $db_table";
$result = mysqli_query($link, $sql) or die ('Unable to Select from DB');

?>
<script language="JavaScript" type="text/JavaScript">
<!--
function CheckAll1()
{
	for (var i=0;i<document.search.elements.length;i++)
	{
 	if(document.search.elements[i].name != 'ALL') document.search.elements[i].checked = document.search.ALL.checked;
  	}
}

function CheckAll2()
{
	for (var i=0;i<document.select.elements.length;i++)
	{
 	if(document.select.elements[i].name != 'ALL') document.select.elements[i].checked = document.select.ALL.checked;
  	}
}

 function Confirm1()
{
var agree=confirm("If you press ok, the checked person(s) will be deleted from the database.");
if (agree)
	return true ;
else
	return false ;
}

 function popUp(URL)
{
day = new Date();
id = day.getTime();
eval("page" + id + " = window.open(URL, '" + id + "', 'scrollbars=1,resizable=1,width=500,height=500,left=350,top=250');");
}
//-->
</script>
<body OnLoad="document.search.search.focus();">
<h1>Identify Duplicates <a href="javascript:popUp('help.php#duplicates')" style="text-decoration:none; border-style:outset; border-width:2px; margin-left:30px; color:#666666; font-size:smaller;"> ? </a></h1>

<?php
echo "<form action=\"$_SERVER[PHP_SELF]\" method=\"post\" name=\"search\">";

//write field names besides check boxes
for ($d = 0; $d < mysqli_field_count($link); $d++)
	{
	$finfo = mysqli_fetch_field_direct($result, $d);

	echo "<input name=\"criterion_".$d."\" type=\"checkbox\" " ;

	//falls "id" Checkbox disablen
	if ($finfo->name == "id") {echo "disabled=\"disabled\" ";}

	echo "value=\"".$finfo->name."\"";

	//memorize setting from last submission
	$compiledkey1 = "criterion_".$d;
	if (isset($_POST[$compiledkey1])) {echo "checked";}

	echo "> ".$finfo->name."<br>";
	}

echo "<br><input name=\"ALL\" type=\"CHECKBOX\" value=\"CHECK ALL\" onClick=\"CheckAll1();\" checked>
			(un-)check all criteria<br><br>

     Skip empty values: <input type=\"radio\" name=\"skip_empty\" value=\"1\" ";
     if ((isset($_POST['skip_empty'])) && ($_POST['skip_empty']==1)) {echo"checked";} echo ">no &nbsp;
     <input type=\"radio\" name=\"skip_empty\" value=\"2\" ";
     if ((!isset($_POST['skip_empty'])) || ($_POST['skip_empty']==2)) {echo"checked";} echo ">yes<br><br>
      <input type=\"submit\" value=\"Identify Duplicates\" style=\"width:200px\" title=\"Submit search form\" name=\"toolbutton_search_duplicates\"></form>";

//search form was submitted
if (isset($_POST['toolbutton_search_duplicates']))
	{
	echo "<hr><h1>Duplicates</h1>";

	/* search panelists according to search criteria
	compose search query
	*/
	$sql2 = "SELECT $db_table.id";

	for ($e = 0; $e < mysqli_field_count($link); $e++) //as often as there are search criteria
		{
			$compiledkey2 = "criterion_".$e;
			if (isset($_POST[$compiledkey2])) //respective search field was part of form
			{
			$sql2 .= ", $db_table.";
			$sql2 .= $_POST[$compiledkey2];
			}
		}

	$sql2 .= " from $db_table, $db_table as t2 WHERE ";

	for ($e = 0; $e < mysqli_field_count($link); $e++) //as often as there are search criteria
		{
			$compiledkey2 = "criterion_".$e;
			if (isset($_POST[$compiledkey2])) //respective search field was part of form
			{
			$sql2 .= "$db_table.";
			$sql2 .= $_POST[$compiledkey2];
			$sql2 .= "=t2.";
			$sql2 .= $_POST[$compiledkey2];

          //if skip_empty = 2 yes
          if ((isset($_POST['skip_empty'])) && ($_POST['skip_empty']==2))
	        {
			$sql2 .= " AND ";  //skip empty values - NULL is skipped anyway
			$sql2 .= "$db_table.";
			$sql2 .= $_POST[$compiledkey2];
			$sql2 .= " !=''";
			    }

			$sql2 .= " AND ";
			}
		}

	$sql2 .= " $db_table.id<>t2.id GROUP BY id ORDER BY ";

	for ($e = 0; $e < mysqli_field_count($link); $e++) //as often as there are search criteria
		{
			$compiledkey3 = "criterion_".$e;
			if (isset($_POST[$compiledkey3])) //respective search field was part of form
			{
			$sql2 .= $_POST[$compiledkey3].", ";
			}
		}
	$sql2 .= "id";

//echo "$sql2";

	$result2 = mysqli_query($link, $sql2) or die ('Unable to Select from DB');

	//no panelist was found
	if (!mysqli_num_rows($result2))
		{
		echo "No person is a duplicate according to the chosen set of criteria.<br><br>If you are surprised by this result you may want to consult the <a href=\"help.php#duplicates\">duplicates help</a>.";
		}

	//at least one panelist was found
	else
		{
		echo "<form action=\"select.php\" method=\"post\" name=\"select\"><table border=\"1\"><tr><th>&nbsp;</th>";

		/* get the field names and write them in first row of a table
		as often as there are different fields */
		for ($c = 0; $c < mysqli_field_count($link); $c++)
			{
			$finfo = mysqli_fetch_field_direct($result2, $c);
			echo "<th align=\"left\" nowrap>".$finfo->name."</th>";
			}
		echo "</tr>";

		//as long as there are rows in the result array
		for ($e = 0; $e < mysqli_num_rows($result2); $e++)
			{
			$ergebnis = mysqli_fetch_row ($result2);
			echo "<tr><td><input name=\"id_".$e."\" type=\"checkbox\" value=\"".$ergebnis[0]."\" checked></td>";

			//as long as there are fields
			for ($f = 0; $f < mysqli_field_count($link); $f++)
				{
				//put out only 35 characters
				echo "<td>".substr($ergebnis[$f],0,35)."</td>";
				}
			echo "</tr>";

			}
		echo "</table><input name=\"ALL\" type=\"CHECKBOX\" value=\"CHECK ALL\" onClick=\"CheckAll2();\" checked>
			 (un-)check all $e panelists<br><br><input type=\"submit\" value=\"View & Alter\" name=\"toolbutton_view_and_alter\" title=\"Submit view & alter form\" style=\"width:130px\"> <input type=\"submit\" value=\"Delete Person(s)\" name=\"toolbutton_delete_rows\" title=\"Submit Delete Person(s) form\" onClick=\"return Confirm1();\" style=\"width:132px\"> <input type=\"submit\" value=\"E-Mail\" name=\"toolbutton_email\" title=\"Submit E-Mail Form\" style=\"width:132px\"></form>";
		}
	}
mysqli_close($link);
}
?>
</body></html>
