<?php
/*
Copyright (C) 2009 Anja S. Gritz <http://www.goeritz.net>
This file is part of phpPanelAdmin.

phpPanelAdmin is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

phpPanelAdmin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpPanelAdmin. If not, see <http://www.gnu.org/licenses/>.
*/
?>

<html><head>
<?php
require 'ppa_admin/config_signup.php';

//form was not submitted; display form
if ((empty($_POST)) AND (empty($_GET)))
{
echo "<title>Registration</title></head><body><h1>Registration Form</h1>";

echo "<form action=\"$_SERVER[PHP_SELF]\" method=\"post\">";

//show signup form, which has been defined in config_signup.php
echo $form_fields;

echo "<input value=\"Submit\" type=\"submit\" title=\"Submit registration form\"></form>";
}

//form was submitted or opt-out
else
{
require 'ppa_admin/config_db.php';

	//form was submitted
	if (!empty($_POST))
	{
	echo "<title>Registration</title></head><body><h1>Registration Form</h1>";

		//input validation
		if ($allfieldsfull)
		{
			foreach($_POST as $name=>$value)
			{
				if ($value == "")
				{
				echo "<br>You need to fill out the field called \"$name\"";
				echo '<br><br><a href="javascript:history.back()">back</a>';
				exit;
				}
		 	}
		}

	//enter more form validation from config_signup.php
	more_input_valid();

	//continue because everything is ok
	echo "$thank_you_text";


	//connect to db server
	$link = mysqli_connect($db_host,$db_user,$db_password,$db_database) or die("Error: ".mysqli_error($link));

		/* 	add colums corresponding to default variables as defined in config_db.php, if not already there */
		foreach ($default_variables as $name=>$value)
		{
		mysqli_query ($link,"ALTER TABLE $db_table ADD $name ".$default_variables[$name][0]."");
		}

	//trim illegal characters from variable names in signup form
	$search = array( "", "", "", "", "", "", "", "!", "", "$", "%", "&", "/", "\x00", "^", "", "\x1a", "-", "\"", " ", "\\", "\0", "\x0B", "\t", "\n", "\r", "(", ")", "=", "?", "`", "*", "'", ":", ";", ">", "<", "{", "}", "[", "]", "~", "", "", "~", "", "@", "|", "<", "+", "#", ".", "", "", "+", ",");
	$replace = array( "ae", "Ae", "oe", "Oe", "ue", "Ue", "ss" );

		//add colums corresponding to form variables, if not already there
		foreach($_POST as $name=>$value)
		{
		//replace illegal characters
		$name = str_replace($search, $replace, $name);
		//add colums for form variables
		mysqli_query ($link, "ALTER TABLE $db_table ADD $name VARCHAR(255)");
		$newarray[$name]=$value;
		}

	$_POST = $newarray;

	//insert new record into db
	mysqli_query($link,"INSERT INTO $db_table VALUES ()") or die(' Unable to insert into table! '.mysqli_error($link));

	/* grab last value of auto-increment variable "identification" to be used as identifier */
	$id = mysqli_insert_id($link);

		//update db table step by step with default variables
		foreach ($default_variables as $name=>$value)
		{
		mysqli_query($link,"UPDATE $db_table SET $name = '".$default_variables[$name][1]."' WHERE id=$id");
		}

		//update db table step by step with form variables
		foreach($_POST as $name=>$value)
		{
		//echo "$name - $value<br>"; //spits out array for control purposes
		mysqli_query($link, "UPDATE $db_table SET $name='".mysqli_real_escape_string($link, $value)."' WHERE id=$id") or die(' Unable to update table '.mysqli_error($link));
		}

		//send confirmation email if requested and email format is correct
		if (($emailconfirm) && (filter_var($_POST['email'], FILTER_VALIDATE_EMAIL) == true))
		{
		//get address from db
		$result = mysqli_query($link, "SELECT email_sender_name, email_sender_address FROM $db_table_admins LIMIT 1") or die (' Unable to select from table! '.mysqli_error($link));
		$row = mysqli_fetch_assoc($result);

		$xtra  = "From: \"".$row['email_sender_name']."\" <".$row['email_sender_address'].">\r\n";
		$xtra  .= "MIME-Version: 1.0\n";
		$xtra  .= "Content-Type: text/plain; charset=ISO-8859-1\r\n";
		$xtra  .= "Content-Transfer-Encoding: base64\r\n\r\n";
				if ($optout)
				{
				$body .= $snippet_optout;
				$body .= "http://$_SERVER[SERVER_NAME]$_SERVER[PHP_SELF]?code=$reg_urlcode&id=$id\n\n";
				}
		mail($_POST['email'], $subject, chunk_split(base64_encode("$body")), $xtra, "-f".$row['email_sender_address']."") or die (' Unable to send e-mail '.mysqli_error($link));
		}

	//close connection
	mysqli_close($link);
	}


	//opt-out was initiated and has been switched on
	elseif ((!empty($_GET)) AND (isset($optout)))
	{
	echo "<title>Opt-Out</title></head><body><h1>Opt-Out Form</h1>";

		//id or code are empty or id is not numeric
		if ((empty($_GET['id'])) OR (empty($_GET['code'])) OR (!is_numeric($_GET['id'])))
		{
		echo('No such record exists. Please try again.');
		exit;
		}

	/* connect to db and check whether id and code are matched */
	$link = mysqli_connect($db_host,$db_user,$db_password,$db_database) or die("Error: ".mysqli_error($link));
	$sql = "SELECT id FROM $db_table WHERE id=".mysqli_real_escape_string($link, $_GET['id'])." AND reg_urlcode='".mysqli_real_escape_string($link, $_GET['code'])."' LIMIT 1";
	$result = mysqli_query($link, $sql) or die (' Unable to Select from DB');

		if (!mysqli_num_rows($result))
		{
		echo('No such record exists. Please try again.');
		mysqli_close($link);
		exit;
		}

		//matched successfully
		else
		{
			//deletion not confirmed
			if (!isset($_GET['delete_confirm'])|| ($_GET['delete_confirm']!=1))
			{
			//display confirmation form
?>
			<form action="<?php echo $_SERVER['PHP_SELF']?>" method="get">
			<input type="hidden" name="id" value="<?php echo $_GET['id']?>"><input type="hidden" name="code" value="<?php echo $_GET['code']?>">
			<input type="hidden" name="delete_confirm" value="1">
			Press this button only if you really want to be deleted: <input value="Delete irrevocably" type="submit"></form>
<?php
			mysqli_close($link);
			exit;
			}

		//delete from db and write into deleted database
		/* determine names and types of fields in db */
		$sql = "SHOW FIELDS FROM $db_table";
		$result = mysqli_query($link, $sql) or die (' Unable to Select from DB');
		$fieldnames = "";

			//traverse fields
			for ($d = 0; $d < mysqli_num_rows($result); $d++)
			{
			$row = mysqli_fetch_assoc($result);
			$fieldnames .= "$row[Field]";
				//add comma until penultimate fieldname
				if ($d < mysqli_num_rows($result)-1)
				{
				$fieldnames .= ",";
				}

			/* create field in $db_table_deleted, in case it might not be there; do not throw error because field might already be present in $db_table_deleted */
			$sql5 ="ALTER TABLE $db_table_deleted ADD $row[Field] $row[Type]";
			mysqli_query($link, $sql5);
			}

		/* relocate person(s) into $db_table_deleted */
		$sql3 = "INSERT INTO $db_table_deleted ($fieldnames) SELECT $fieldnames FROM $db_table WHERE id=".mysqli_real_escape_string($link, $_GET['id']);
		mysqli_query($link, $sql3) or die( ' Unable to read from or insert into table! '.mysqli_error($link));

		/* include del_date, del_time, and del_reason in $db_table_deleted */
		mysqli_query($link, "UPDATE $db_table_deleted SET del_date = '".date('Y-m-d')."', del_time = '".date('G:i:s')."', del_reason= '[panelist] opted-out' WHERE id=".mysqli_real_escape_string($link,$_GET['id'])."");

		/* delete person(s) from $db_table */
		$sql4 = "DELETE FROM $db_table WHERE id=".mysqli_real_escape_string($link, $_GET['id']);
		$result = mysqli_query($link, $sql4) or die ('<br>Unable to delete from Table $db_table. '.mysqli_error($link));

		mysqli_close($link);

		//display confirmation
		echo "$optout_text";
		}
	}

	//none of the above
	else
	{
	echo "<title>Undefined</title></head><body>";
	echo "This action is not defined.";
	}
}
?>
</body></html>
