<?php
/*
Copyright (C) 2009 Anja S. Gritz <http://www.goeritz.net>
This file is part of phpPanelAdmin.

phpPanelAdmin is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

phpPanelAdmin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpPanelAdmin. If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
if(!isset($_SESSION['admin']))
{
echo "Processing impossible!<br>";
echo "<a href=\"index.php\">Login?</a>";
}

else //cookie is there
{
?>
<html><head><title>Panel Overview</title>
<script language="JavaScript" type="text/JavaScript">
<!--
 function popUp(URL)
{
day = new Date();
id = day.getTime();
eval("page" + id + " = window.open(URL, '" + id + "', 'scrollbars=1,resizable=1,width=500,height=500,left=350,top=250');");
}
//-->
</script>
</head><body>
<?php
require 'header.php';

$link2 = mysqli_connect($db_host,$db_user,$db_password,$db_database) or die("Error: ".mysqli_error($link2));
$sql = "SELECT * FROM $db_table";
$result = mysqli_query($link, $sql) or die ('Unable to Select from DB');
?>
<h1>Panel Overview <a href="javascript:popUp('help.php#panel_overview')" style="text-decoration:none; border-style:outset; border-width:2px; margin-left:30px; color:#666666; font-size:smaller;"> ? </a></h1>
<?php
echo "There are <b>".mysqli_num_rows($result)." </b> people in the panel.<br>";
?>
<br>
<form action="" name="not_to_submit">
<table><thead>
<tr>
<th align="left" style="width:40%;">Variables</th>
<th align="left" style="width:60%;">value (absolute frequency) (relative frequency) </th>
</tr>
</thead>
<tbody>
<?php
/* get the field names and write them in first column of a table
as often as there are fields */
for ($c = 0; $c < mysqli_field_count($link); $c++)
	{

	//set limit for number of rows in drop-down menue
	$limit = 50;
	$finfo = mysqli_fetch_field_direct($result, $c);

	echo "<tr><td>".$finfo->name."</td>
	<td><select name=\"".$finfo->name."\" style=\"width:333\">
	<option>View ...</option>";

	//fetch unique values for field
	$result1 = mysqli_query($link2, "SELECT ".$finfo->name.", COUNT(".$finfo->name." IS NULL) from $db_table GROUP BY ".$finfo->name." ASC LIMIT $limit") or die("No Way!");


	/* populate drop-down menu with unique values of field
	as long as there are rows in the result array */
	for ($e = 0; $e < mysqli_num_rows($result1); $e++)
		{

		/* truncation limit is reached, write last option as "..." */
		if ($e == $limit-1)
			{
			echo "<option>...There are at least $limit values. The remaining values will not be displayed...</option>";
			}
		//truncation limit is not reached
		else
			{
			$value = mysqli_fetch_row ($result1);

			//value is NULL
			if (is_null($value[0]))
				{
				$value[0] = "--NULL--";
				}
			elseif ($value[0] == "")
				{
				$value[0] = "--EMPTY--";
				}

			/* determine relative frequency and round result of division to 1 decimal place */
			$percentage = round($value[1] / mysqli_num_rows($result)*100,1);
			echo "<option>$value[0] (".$value[1].") (".$percentage."%) </option>";
			}
		}
		echo "</td></tr>";
	}
mysqli_close($link2);
mysqli_close($link);
echo "</tbody></table></form>";
}
?>

